unit heex_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Menus,
  ComCtrls, ExtCtrls, crt, hat_eeprom_ctlr;

type

  { TfHatEeprom }

  TfHatEeprom = class(TForm)
    bNewUUID: TButton;
    eaGPIO0: TEdit;
    eaGPIO1: TEdit;
    eaGPIO10: TEdit;
    eaGPIO11: TEdit;
    eaGPIO12: TEdit;
    eaGPIO13: TEdit;
    eaGPIO14: TEdit;
    eaGPIO15: TEdit;
    eaGPIO16: TEdit;
    eaGPIO17: TEdit;
    eaGPIO18: TEdit;
    eaGPIO19: TEdit;
    eaGPIO2: TEdit;
    eaGPIO20: TEdit;
    eaGPIO21: TEdit;
    eaGPIO22: TEdit;
    eaGPIO23: TEdit;
    eaGPIO24: TEdit;
    eaGPIO25: TEdit;
    eaGPIO26: TEdit;
    eaGPIO27: TEdit;
    eaGPIO3: TEdit;
    eaGPIO4: TEdit;
    eaGPIO5: TEdit;
    eaGPIO6: TEdit;
    eaGPIO7: TEdit;
    eaGPIO8: TEdit;
    eaGPIO9: TEdit;
    eaCustomCRC: TEdit;
    eaCustomLen: TEdit;
    eaCustomNo: TEdit;
    eaVendorCRC: TEdit;
    eaGPIOCRC: TEdit;
    eaGPIOLen: TEdit;
    eaVendorNo: TEdit;
    eaVendorLen: TEdit;
    eaGPIONo: TEdit;
    eaGPIOBank: TEdit;
    eaGPIOPower: TEdit;
    eRPi: TEdit;
    eProductID: TEdit;
    eProductVer: TEdit;
    eUUID: TEdit;
    eVersion: TEdit;
    eNumAtoms: TEdit;
    eELen: TEdit;
    eVendor: TEdit;
    eProduct: TEdit;
    Label1: TLabel;
    LabelNum10: TLabel;
    LabelNum6: TLabel;
    LabelNum7: TLabel;
    LabelNum8: TLabel;
    LabelNum9: TLabel;
    lGPIO0: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    LabelNum5: TLabel;
    LabelNum1: TLabel;
    LabelNum2: TLabel;
    LabelNum3: TLabel;
    Label3: TLabel;
    LabelNum: TLabel;
    LabelNum4: TLabel;
    hexMenu: TMainMenu;
    lGPIO1: TLabel;
    lGPIO2: TLabel;
    lGPIO3: TLabel;
    mDump: TMemo;
    mCustom: TMemo;
    miInitAtoms: TMenuItem;
    miSettings: TMenuItem;
    miC16: TMenuItem;
    miC32: TMenuItem;
    miC64: TMenuItem;
    miC128: TMenuItem;
    miC256: TMenuItem;
    MenuItem7: TMenuItem;
    miValidateAtom: TMenuItem;
    miAtoms: TMenuItem;
    miFlash: TMenuItem;
    miBlank: TMenuItem;
    miLoad: TMenuItem;
    miEeprom: TMenuItem;
    miFile: TMenuItem;
    miOpen: TMenuItem;
    miSave: TMenuItem;
    miQuit: TMenuItem;
    odFile: TOpenDialog;
    pcDatas: TPageControl;
    sdFile: TSaveDialog;
    tsCustom: TTabSheet;
    tsGPIO: TTabSheet;
    tsVendor: TTabSheet;
    tsHeader: TTabSheet;
    tsBuffer: TTabSheet;
    procedure FormCreate(Sender: TObject);
    procedure bNewUUIDClick(Sender: TObject);
    procedure miBlankClick(Sender: TObject);
    procedure miCapacityClick(Sender: TObject);
    procedure miValidateAtomClick(Sender: TObject);
    procedure miFlashClick(Sender: TObject);
    procedure miInitAtomsClick(Sender: TObject);
    procedure miLoadClick(Sender: TObject);
    procedure miOpenClick(Sender: TObject);
    procedure miQuitClick(Sender: TObject);
    procedure miSaveClick(Sender: TObject);

    procedure Test;
  private
    Eeprom: THat_eeprom_ctlr;
    eaGPIOConfig: array[0..27] of TEdit;
    procedure ShowBuffer; overload;
    procedure ShowBuffer(AMemo: TMemo; addrStart, AddrEnd: UInt32); overload;
    procedure ShowAtoms;
  public

  end;

var
  fHatEeprom: TfHatEeprom;

implementation

{$R *.lfm}



{ TfHatEeprom }

procedure TfHatEeprom.FormCreate(Sender: TObject);
begin
  Eeprom:= THat_eeprom_ctlr.Create(Self, ec32);
  pcDatas.ActivePage:= tsBuffer;
  tsHeader.TabVisible:= False;
  tsVendor.TabVisible:= False;
  tsGPIO.TabVisible:= False;
  tsCustom.TabVisible:= False;
  // GPIO edits as array
  eaGPIOConfig[0]:= eaGPIO0;
  eaGPIOConfig[1]:= eaGPIO1;
  eaGPIOConfig[2]:= eaGPIO2;
  eaGPIOConfig[3]:= eaGPIO3;
  eaGPIOConfig[4]:= eaGPIO4;
  eaGPIOConfig[5]:= eaGPIO5;
  eaGPIOConfig[6]:= eaGPIO6;
  eaGPIOConfig[7]:= eaGPIO7;
  eaGPIOConfig[8]:= eaGPIO8;
  eaGPIOConfig[9]:= eaGPIO9;
  eaGPIOConfig[10]:= eaGPIO10;
  eaGPIOConfig[11]:= eaGPIO11;
  eaGPIOConfig[12]:= eaGPIO12;
  eaGPIOConfig[13]:= eaGPIO13;
  eaGPIOConfig[14]:= eaGPIO14;
  eaGPIOConfig[15]:= eaGPIO15;
  eaGPIOConfig[16]:= eaGPIO16;
  eaGPIOConfig[17]:= eaGPIO17;
  eaGPIOConfig[18]:= eaGPIO18;
  eaGPIOConfig[19]:= eaGPIO19;
  eaGPIOConfig[20]:= eaGPIO20;
  eaGPIOConfig[21]:= eaGPIO21;
  eaGPIOConfig[22]:= eaGPIO22;
  eaGPIOConfig[23]:= eaGPIO23;
  eaGPIOConfig[24]:= eaGPIO24;
  eaGPIOConfig[25]:= eaGPIO25;
  eaGPIOConfig[26]:= eaGPIO26;
  eaGPIOConfig[27]:= eaGPIO27;

  //Test;
end;

procedure TfHatEeprom.miQuitClick(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TfHatEeprom.bNewUUIDClick(Sender: TObject);
begin
  Eeprom.NewUUID;
  eUUID.Text:= GUIDToString(Eeprom.Atoms.Vendor.UUID);
end;


procedure TfHatEeprom.miBlankClick(Sender: TObject);
begin
  Eeprom.BlankEprom;
  ShowMessage('Done');
end;

procedure TfHatEeprom.miCapacityClick(Sender: TObject);
begin
  // set
  if Sender = miC16
    then Eeprom.EpromType:= ec16
    else if Sender = miC32
      then Eeprom.EpromType:= ec32
      else if Sender = miC64
        then Eeprom.EpromType:= ec64
        else if Sender = miC128
          then Eeprom.EpromType:= ec128
          else if Sender = miC256
            then Eeprom.EpromType:= ec256;
  // display
  TMenuItem(Sender).Checked:=True;
end;

procedure TfHatEeprom.miValidateAtomClick(Sender: TObject);
type TCal = record Gain: double; Offset: double; end;
var rCal: TCal;
begin
  Eeprom.InitAtoms(eVendor.Text, eProduct.Text, StrToInt(eProductID.Text), StrToInt(eProductVer.Text));
  Eeprom.AtomsToBuffer;
  ShowBuffer;
  ShowAtoms;
end;

procedure TfHatEeprom.miFlashClick(Sender: TObject);
begin
  if MessageDlg('Confirm flash : all previous datas will be destroyed',
                            mtWarning, [mbOK, mbCancel], 0) <> mrOK then Exit;
  Eeprom.BufferToEprom;
  ShowMessage('Done');
end;

procedure TfHatEeprom.miInitAtomsClick(Sender: TObject);
begin
  tsBuffer.TabVisible:= False;
  tsHeader.TabVisible:= False;

  tsVendor.TabVisible:= True;
  eaVendorNo.Text:= '';
  eaVendorLen.Text:= '';
  eaVendorCRC.Text:= '';
  bNewUUIDClick(Sender);
  eProductID.Text:= '1';
  eProductVer.Text:= '1';
  eVendor.Text:= '< your company>';
  eProduct.Text:=  '< your product name>';

  tsGPIO.TabVisible:= False;
  tsCustom.TabVisible:= False;
end;

procedure TfHatEeprom.miLoadClick(Sender: TObject);
begin
  // refresh data
  Eeprom.EpromToBuffer;
  Eeprom.ParseBuffer;
  // display datas
  ShowBuffer;
  ShowAtoms;
end;

procedure TfHatEeprom.miOpenClick(Sender: TObject);
begin
  if not odFile.Execute then Exit;
  Eeprom.HexFileToBuffer(odFile.FileName);
  ShowBuffer;
end;

procedure TfHatEeprom.miSaveClick(Sender: TObject);
begin
  if not sdFile.Execute then Exit;
  Eeprom.BufferToHexFile(sdFile.Filename);
end;

procedure TfHatEeprom.ShowBuffer;
begin
  ShowBuffer(mDump, 0, Length(Eeprom.EpromBuffer)-1 );
  tsBuffer.TabVisible:= True;
end;

procedure TfHatEeprom.ShowBuffer(AMemo: TMemo; addrStart, AddrEnd: UInt32);
const
  sDump=  '%s: %s   %s';
var i, iStart, iEnd: LongInt;
    asHex, asChar: AnsiString;
    buf: array of byte;
begin
  AMemo.Lines.Clear;
  asHex:= '';
  asChar:= '';
  buf:= Eeprom.EpromBuffer;
  iStart:= addrStart - (addrStart and $F);
  iEnd:= AddrEnd or $F;
  for i:=iStart to iEnd do
  begin
    if (i < addrStart) or (i > AddrEnd)
    then begin
      asHex:= asHex + '   ';
      asChar:= asChar + '.';
    end
    else begin
      asHex:= asHex + IntToHex(buf[i], 2) + ' ';
      if (buf[i] >= $20) and  (buf[i] < $7F)
        then asChar:= asChar + char(buf[i])
        else asChar:= asChar + '.';
    end;
  if (i and $F = $F)
    then begin
      AMemo.Lines.Add( Format(sDump, [IntToHex(i-$F, 4), asHex, asChar]) );
      asHex:= '';
      asChar:= '';
      AMemo.Update;
      Application.ProcessMessages;
    end;
  end;
end;

procedure TfHatEeprom.ShowAtoms;
var i: integer;
    dStart, dEnd: UInt32;
begin
  tsHeader.TabVisible:= True;
  eRPi.Text := Eeprom.Atoms.Header.signature;
  eVersion.Text := IntToStr(Eeprom.Atoms.Header.version);
  eNumAtoms.Text := IntToStr(Eeprom.Atoms.Header.numAtoms);
  eELen.Text := IntToStr(Eeprom.Atoms.Header.eepLen);

  tsVendor.TabVisible:= True;
  eaVendorNo.Text:= IntToStr(Eeprom.Atoms.Vendor.count);
  eaVendorLen.Text:= IntToStr(Eeprom.Atoms.Vendor.dLen);
  eaVendorCRC.Text:= '0x' + IntToHex(Eeprom.Atoms.Vendor.crc16, 4);
  eUUID.Text:= GUIDToString(Eeprom.Atoms.Vendor.UUID);
  eProductID.Text:= IntToStr(Eeprom.Atoms.Vendor.pid);
  eProductVer.Text:= IntToStr(Eeprom.Atoms.Vendor.pver);
  eVendor.Text:= Eeprom.Atoms.Vendor.vstr;
  eProduct.Text:= Eeprom.Atoms.Vendor.pstr;

  tsGPIO.TabVisible:= True;
  eaGPIONo.Text:= IntToStr(Eeprom.Atoms.GPIO.count);
  eaGPIOLen.Text:= IntToStr(Eeprom.Atoms.GPIO.dLen);
  eaGPIOCRC.Text:= '0x' + IntToHex(Eeprom.Atoms.GPIO.crc16, 4);
  eaGPIOBank.Text:= '0x' + IntToHex(Eeprom.Atoms.GPIO.bank_drive, 2);
  eaGPIOPower.Text:= '0x' + IntToHex(Eeprom.Atoms.GPIO.power, 2);
  for i:= Low(eaGPIOConfig) to High(eaGPIOConfig) do
    eaGPIOConfig[i].Text:= '0x' + IntToHex(Eeprom.Atoms.GPIO.IO[i], 2);

  if Length(Eeprom.Atoms.Customs) > 0
  then begin
    tsCustom.TabVisible:= True;
    eaCustomNo.Text:= IntToStr(Eeprom.Atoms.Customs[0].count);
    eaCustomLen.Text:= IntToStr(Eeprom.Atoms.Customs[0].dLen);
    eaCustomCRC.Text:= '0x' + IntToHex(Eeprom.Atoms.Customs[0].crc16, 4);
    dStart:= Eeprom.Atoms.Customs[0].dataOffset;
    dEnd:= dStart + Eeprom.Atoms.Customs[0].dLen - SizeOf(TheaCustom.crc16) - 1;
    ShowBuffer(mCustom, dStart, dEnd);
  end
  else tsCustom.TabVisible:= False;
end;


{  Example to add custom }
procedure TfHatEeprom.Test;
type TCal = record case boolean of
               True : ( Gain: double; Offset: double; );
               False : (Bytes: array[0..15] of byte);
            end;
var rCal: TCal;
begin
  rCal.Gain:= 1.;
  rCal.Offset:= 1.;
  Eeprom.SaveToCustom(0, rCal, SizeOf(TCal));


//  Eeprom.AddCustom(rCal, SizeOf(TCal));
//  Eeprom.AtomsToBuffer;



  ShowBuffer;
  ShowAtoms;
end;


end.

